ReplaceRegExp (Apache Ant API)
Keywords: org.apache.tools.ant.taskdefs.optional.ReplaceRegExp class

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.tools.ant.taskdefs.optional
Class ReplaceRegExp

    java.lang.Object
      org.apache.tools.ant.ProjectComponent
          org.apache.tools.ant.Task
              org.apache.tools.ant.taskdefs.optional.ReplaceRegExp

public class ReplaceRegExp
extends Task

Performs regular expression string replacements in a text file. The input file(s) must be able to be properly processed by a Reader instance. That is, they must be text only, no binary. The syntax of the regular expression depends on the implemtation that you choose to use. The system property `ant.regexp.regexpimpl` will be the classname of the implementation that will be used (the default is `org.apache.tools.ant.util.regexp.JakartaOroRegexp` and requires the Jakarta Oro Package).

     For jdk  <= 1.3, there are two available implementations:
       org.apache.tools.ant.util.regexp.JakartaOroRegexp (the default)
            Requires  the jakarta-oro package

       org.apache.tools.ant.util.regexp.JakartaRegexpRegexp
            Requires the jakarta-regexp package

     For jdk >= 1.4 an additional implementation is available:
       org.apache.tools.ant.util.regexp.Jdk14RegexpRegexp
            Requires the jdk 1.4 built in regular expression package.

     Usage:

       Call Syntax:

         <replaceregexp file="file"
                        match="pattern"
                        replace="pattern"
                        flags="options"?
                        byline="true|false"? >
           regexp?
           substitution?
           fileset*
         </replaceregexp>

        NOTE: You must have either the file attribute specified, or at least one fileset subelement
        to operation on.  You may not have the file attribute specified if you nest fileset elements
        inside this task.  Also, you cannot specify both match and a regular expression subelement at
        the same time, nor can you specify the replace attribute and the substitution subelement at
        the same time.

       Attributes:

         file    --> A single file to operation on (mutually exclusive with the fileset subelements)
         match   --> The Regular expression to match
         replace --> The Expression replacement string
         flags   --> The options to give to the replacement
                     g = Substitute all occurrences. default is to replace only the first one
                     i = Case insensitive match

         byline  --> Should this file be processed a single line at a time (default is false)
                     "true" indicates to perform replacement on a line by line basis
                     "false" indicates to perform replacement on the whole file at once.

      Example:

         The following call could be used to replace an old property name in a ".properties"
         file with a new name.  In the replace attribute, you can refer to any part of the
         match expression in parenthesis using backslash followed by a number like '\1'.

         <replaceregexp file="test.properties"
                        match="MyProperty=(.*)"
                        replace="NewProperty=\1"
                        byline="true" />

Author:
  Matthew Inger

Field Summary

Fields inherited from class org.apache.tools.ant.Task
`description, location, target, taskName, taskType, wrapper`

Fields inherited from class org.apache.tools.ant.ProjectComponent
`project`

Constructor Summary
`ReplaceRegExp()` Default Constructor

Method Summary
`void` | `addFileset(FileSet set)` list files to apply the replacement to
`RegularExpression` | `createRegexp()` A regular expression.
`Substitution` | `createSubstitution()` A substitution pattern.
`protected void` | `doReplace(java.io.File f, int options)` Perform the replace on the entire file
`protected java.lang.String` | `doReplace(RegularExpression r, Substitution s, java.lang.String input, int options)`
`void` | `execute()` Called by the project to let the task do its work.
`void` | `setByLine(java.lang.String byline)` Process the file(s) one line at a time, executing the replacement on one line at a time.
`void` | `setFile(java.io.File file)` file for which the regular expression should be replaced; required unless a nested fileset is supplied.
`void` | `setFlags(java.lang.String flags)` The flags to use when matching the regular expression.
`void` | `setMatch(java.lang.String match)` the regular expression pattern to match in the file(s); required if no nested <regexp> is used
`void` | `setReplace(java.lang.String replace)` The substitution pattern to place in the file(s) in place of the regular expression.

Methods inherited from class org.apache.tools.ant.Task
`getDescription, getLocation, getOwningTarget, getRuntimeConfigurableWrapper, getTaskName, handleErrorFlush, handleErrorOutput, handleFlush, handleOutput, init, isInvalid, log, log, maybeConfigure, perform, setDescription, setLocation, setOwningTarget, setRuntimeConfigurableWrapper, setTaskName`

Methods inherited from class org.apache.tools.ant.ProjectComponent
`getProject, setProject`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### ReplaceRegExp

    public ReplaceRegExp()

  Default Constructor

Method Detail

### setFile

    public void setFile(java.io.File file)

  file for which the regular expression should be replaced; required unless a nested fileset is supplied.

### setMatch

    public void setMatch(java.lang.String match)

  the regular expression pattern to match in the file(s); required if no nested <regexp> is used

### setReplace

    public void setReplace(java.lang.String replace)

  The substitution pattern to place in the file(s) in place of the regular expression. Required if no nested <substitution> is used

### setFlags

    public void setFlags(java.lang.String flags)

  The flags to use when matching the regular expression. For more information, consult the Perl5 syntax.
  - g : Global replacement. Replace all occurences found
  - i : Case Insensitive. Do not consider case in the match
  - m : Multiline. Treat the string as multiple lines of input, using "^" and "$" as the start or end of any line, respectively, rather than start or end of string.
  - s : Singleline. Treat the string as a single line of input, using "." to match any character, including a newline, which normally, it would not match.

### setByLine

    public void setByLine(java.lang.String byline)

  Process the file(s) one line at a time, executing the replacement on one line at a time. This is useful if you want to only replace the first occurence of a regular expression on each line, which is not easy to do when processing the file as a whole. Defaults to false.

### addFileset

    public void addFileset(FileSet set)

  list files to apply the replacement to

### createRegexp

    public RegularExpression createRegexp()

  A regular expression. You can use this element to refer to a previously defined regular expression datatype instance

### createSubstitution

    public Substitution createSubstitution()

  A substitution pattern. You can use this element to refer to a previously defined substitution pattern datatype instance.

### doReplace

    protected java.lang.String doReplace(RegularExpression r,
                                         Substitution s,
                                         java.lang.String input,
                                         int options)

### doReplace

    protected void doReplace(java.io.File f,
                             int options)
                      throws java.io.IOException

  Perform the replace on the entire file

  Throws:
    `java.io.IOException`

### execute

    public void execute()
                 throws BuildException

  Description copied from class: `Task`
  Called by the project to let the task do its work. This method may be called more than once, if the task is invoked more than once. For example, if target1 and target2 both depend on target3, then running "ant target1 target2" will run all tasks in target3 twice.

  Overrides:
    `execute` in class `Task`
  Throws:
    `BuildException` - if something goes wrong with the build

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2003 Apache Software Foundation. All Rights Reserved.